<p>Nakon što smo u opis sklopa uključili biblioteku <code>ieee</code> i potrebne tipove podataka te nakon napisanog
   sučelja sklopa, da bi specifikacija bila potpuna, moramo još napisati arhitekturu sklopa.
</p>

<p>Sučelje sklopa <em>sklop1</em> koji koristimo kao radni primjer već smo prikazali - ponavljamo ga na slici 1
   u nastavku.
</p>

<figure class="mlFigure">
<img src="@#file#(sklop1i.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Sučelje sklopa <em>sklop1</em>.</figcaption>
</figure>

<p>Prije no što krenemo u specificiranje arhitekture tog sklopa, i mi sami moramo znati što točno taj sklop radi.
   Stoga je na slici 2 prikazana logička shema iz koje je vidljivo na koji se način na temelju ulaza generiraju
   izlazi.
</p>

<figure class="mlFigure">
<img src="@#file#(sklop1.svg)" alt="Logička shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Logička shema sklopa <em>sklop2</em>.</figcaption>
</figure>

<p>Sada možemo odgovoriti na pitanje: što je arhitektura sklopa?</p>

<p>Arhitektura sklopa specificira opis unutrašnjosti "crne kutije". Dok sučelje specificira način na koji sklop
   interagira s okolinom (koji su mu ulazi a koji izlazi), arhitektura specificira način na koji se na temelju
   ulaza generiraju izlazi.
</p>

<p>Kako smo u uvodnom dijelu napomenuli, ta specifikacija (arhitektura sklopa) može biti definirana na više načina. 
   U određenim slučajevima, u opisu ćemo čak i kombinirati elemente različitih načina opisivanja &#8212; takav ćemo
   opis onda zvati <em>hibridni opis</em>.
</p>

<p>Specifikacija arhitekture jezikom VHDL sastoji se od nekoliko dijelova. Struktura jednog takvog opisa prikazana
   je u nastavku.
</p>

<div style="border-left: 4px solid #0F0; background-color: #cfc; padding: 5px; margin-top: 10px; margin-bottom: 10px;">
<code>ARCHITECTURE</code> <em>nazivArhitekture</em> <code>OF</code> <em>nazivSklopa</em> <code>IS</code><br>
&nbsp;&nbsp;<em>opcionalne deklaracije pomoćnih signala i konstanti</em><br>
<code>BEGIN</code><br>
&nbsp;&nbsp;<em>specifikacija tijela arhitekture</em><br>
<code>END</code> <em>opcionalno:</em><code>ARCHITECTURE</code> <em>opcionalno:nazivArhitekture</em> <code>;</code>
</div>

<p>Deklaracija arhitekture sklopa započinje navođenjem ključne riječi <code>ARCHITECTURE</code>, nakon čega slijedi
   naziv arhitekture, ključna riječ <code>OF</code>, naziv sklopa čija je to arhitektura pa ključna riječ
   <code>IS</code>. Slijedi dio u kojem po potrebi možemo definirati pomoćne (unutarnje odnosno interne) signale,
   konstante i nove tipove podataka. Nakon toga dolazi ključna riječ <code>BEGIN</code>, jedna ili više naredbi 
   koje zajedno opisuju na koji se način na temelju ulaza sklopa generiraju vrijednosti koje se postavljaju na 
   izlaze sklopa te ključna riječ <code>END</code>, naziv arhitekture i točka-zarez (u zatvaranju arhitekture
   uobičajeno ćemo preskakati ključnu riječ <code>ARCHITECTURE</code>.
</p>
<p>VHDL naredbe koje se u arhitekturi nalaze između ključnih riječi <code>BEGIN</code> i <code>END</code>
   čine tijelo arhitekture. Ovisno o vrsti naredbi koje ćemo tu koristiti, napisani model bit će
   model toka podataka, strukturni model ili ponašajni model.
</p>
<p>U nastavku ćemo za <em>sklop1</em> napisati model toka podataka: to je model kod kojeg u jeziku VHDL izravno
   pišemo logičke izraze koji definiraju kako se djelovanjem logičkih operatora na temelju ulaza generiraju 
   izlazi. Da bismo to mogli, moramo najprije sa slike 2 pročitati logičke izraze koji odgovaraju izlazima
   <em>f</em> i <em>g</em>. Vidimo da vrijedi:
\[
  f = a \cdot b
\]
\[
  g = (a + c) \cdot b
\]
</p>
<p>U specifikaciji sučelja sklopa već smo definirali da su <em>a</em>, <em>b</em> i <em>c</em> ulazi a 
   <em>f</em> i <em>g</em> izlazi. Prisjetimo se što smo napisali.
</p>

<pre><code>library ieee;
use ieee.std_logic_1164.all;

ENTITY sklop1 IS PORT (
  a, b, c: IN std_logic;
  f, g: OUT std_logic
);
END sklop1;</code></pre>

<p>Sada nam je ostalo još napisati i specifikaciju arhitekture. U jeziku VHDL, operator kojim se nekom signalu
   (primjerice izlaznom portu ili pomoćnom signalu) pridjeljuje vrijednost je <code>&lt;=</code>. Stoga logičkom
   izrazu:<br>
\(
  f = a \cdot b
\)<br>
   odgovara VHDL naredba:<br>
   <code>f &lt;= a and b;</code><br>
   a logičkom izrazu:<br>
\(
  g = (a + c) \cdot b
\)<br>
   odgovara VHDL naredba:<br>
   <code>g &lt;= (a or c) and b;</code>
</p>

<p>Arhitekturi ćemo dati ime <em>arch1</em> (ponekad se, ovisno o vrsti arhitekture koriste imena poput
   <em>behavioral</em> ili <em>structural</em>; nemojte te naziva pomiješati s ključnim riječima: to su
   obični nazivi). Uzevši ovo sve u obzir, spremni smo napisati arhitekturu.
</p>

<pre><code>ARCHITECTURE arch1 OF sklop1 IS
  -- ne koristimo pomoćne signale
BEGIN
  f &lt;= a AND b;
  g &lt;= (a OR c) AND b;
END arch1;</code></pre>

<p>U prethodnom kodu sve što je navedeno iza <code>--</code> čini komentar. Naziv arhitekture može biti bilo kakav
   valjan identifikator. Treba napomenuti da opći oblik opisa jednog sklopa može imati još neke elemente, ali na 
   ovom mjestu ih nećemo navoditi.
</p>

<p>Operator <code>&lt;=</code> u prethodnom primjeru je operator kojim se vrijednost izraza navedenog 
   s desne strane pridružuje izlazu (odnosno općenito nekom signalu) navedenom s lijeve strane. Ako prije znaka 
   točka-zarez dođe ključna riječ <code>AFTER</code> i nakon toga dođe specifikacija vremena, time se definira 
   da se to pridruživanje događa uz navedeno kašnjenje. Primjerice:<br>
   <code>f &lt;= a AND b AFTER 10 ns;</code><br>
   Na ovaj način dobiva se mogućnost modeliranja kašnjenja u digitalnim sklopovima. Vrijeme koje se navodi ima 
   iznos i mjernu jedinicu (između iznosa i mjerne jedinice mora biti barem jedan razmak). U danom primjeru 
   specificirali smo da izlaz <em>f</em> ima kašnjenje od 10 nanosekundi.
</p>

<p>Važno je za napomenuti da se navedena kašnjenja u cijelosti zanemaruju prilikom sinteze u ciljni programirljivi
   modul (primjerice u neki FPGA): koliko će u stvarnosti kasniti generiranje vrijednosti za izlaz <em>f</em> ovisi 
   isključivo o parametrima programirljivog modula. Međutim, ako znamo poprilici kakvi su parametri programirljivog
   modula, ključna riječ <code>AFTER</code> omogućava nam da naredbama pridijelimo kašnjenja kako bi <strong>pri 
   izvođenju simulacije rada sklopa</strong> dobili realniji prikaz.
</p>

<div class="mlNote">
 <p>
   Sve naredbe koje smo napisali u tijelu arhitekture izvode se istovremeno. Redoslijed naredbi nema nikakvog
   utjecaja na specifikaciju.
 </p>
</div>

